﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Input;
using BindingNavigator;

namespace WpfApplication1
{
    public class MyViewModel
    {
        public MyViewModel()
        {
            this.People = GetPeople();
            this.AddNewPersonCommand = new RelayCommand(this.AddNewPerson);
            this.DeletePersonCommand = new RelayCommand(this.DeletePerson);
            this.SaveCommand = new RelayCommand(this.Save);

            this.People.CollectionChanged += (o, e) =>
            {
                System.Diagnostics.Debug.WriteLine("People in collection: " + this.People.Count);
            };
        }

        public ObservableCollection<Person> People
        {
            get;
            private set;
        }

        private static ObservableCollection<Person> GetPeople()
        {
            var col = new ObservableCollection<Person>();

            for (int i = 1; i <= 15; i++)
            {
                col.Add(new Person { FirstName = "FirstName" + i, LastName = "LastName" + i });
            }  

            return col;
        }

        public ICommand AddNewPersonCommand
        {
            get;
            private set;
        }

        public ICommand DeletePersonCommand
        {
            get;
            private set;
        }

        public ICommand SaveCommand
        {
            get;
            private set;
        }

        private void AddNewPerson(object parameter)
        {
            this.People.Add(new Person());
        }

        private void DeletePerson(object parameter)
        {
            var person = parameter as Person;
            if (person != null)
            {
                this.People.Remove(person);
            }
        }

        private void Save(object parameter)
        {
            MessageBox.Show("Here you can implement logic to save to Database, file, call service, etc.");
        }
    }
}
